/* Utils.c generated by valac 0.54.4, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2018–2021 Cassidy James Blaede <c@ssidyjam.es>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	DIPPI_UTILS_DISPLAY_TYPE_INTERNAL,
	DIPPI_UTILS_DISPLAY_TYPE_EXTERNAL
} DippiUtilsDisplayType;

#define DIPPI_UTILS_TYPE_DISPLAY_TYPE (dippi_utils_display_type_get_type ())

VALA_EXTERN GType dippi_utils_display_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* dippi_utils_display_type_to_string (DippiUtilsDisplayType self);
VALA_EXTERN gchar* dippi_utils_display_type_icon_suffix (DippiUtilsDisplayType self);
VALA_EXTERN gint dippi_utils_dpi (gdouble inches,
                      gint width,
                      gint height);
VALA_EXTERN gint dippi_utils_greatest_common_divisor (gint a,
                                          gint b);

gchar*
dippi_utils_display_type_to_string (DippiUtilsDisplayType self)
{
	gchar* result = NULL;
	switch (self) {
		case DIPPI_UTILS_DISPLAY_TYPE_INTERNAL:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Laptop"));
			result = _tmp0_;
			return result;
		}
		case DIPPI_UTILS_DISPLAY_TYPE_EXTERNAL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Desktop"));
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gchar*
dippi_utils_display_type_icon_suffix (DippiUtilsDisplayType self)
{
	gchar* result = NULL;
	switch (self) {
		case DIPPI_UTILS_DISPLAY_TYPE_INTERNAL:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("-notebook");
			result = _tmp0_;
			return result;
		}
		case DIPPI_UTILS_DISPLAY_TYPE_EXTERNAL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("");
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
dippi_utils_display_type_get_type_once (void)
{
	static const GEnumValue values[] = {{DIPPI_UTILS_DISPLAY_TYPE_INTERNAL, "DIPPI_UTILS_DISPLAY_TYPE_INTERNAL", "internal"}, {DIPPI_UTILS_DISPLAY_TYPE_EXTERNAL, "DIPPI_UTILS_DISPLAY_TYPE_EXTERNAL", "external"}, {0, NULL, NULL}};
	GType dippi_utils_display_type_type_id;
	dippi_utils_display_type_type_id = g_enum_register_static ("DippiUtilsDisplayType", values);
	return dippi_utils_display_type_type_id;
}

GType
dippi_utils_display_type_get_type (void)
{
	static volatile gsize dippi_utils_display_type_type_id__volatile = 0;
	if (g_once_init_enter (&dippi_utils_display_type_type_id__volatile)) {
		GType dippi_utils_display_type_type_id;
		dippi_utils_display_type_type_id = dippi_utils_display_type_get_type_once ();
		g_once_init_leave (&dippi_utils_display_type_type_id__volatile, dippi_utils_display_type_type_id);
	}
	return dippi_utils_display_type_type_id__volatile;
}

gint
dippi_utils_dpi (gdouble inches,
                 gint width,
                 gint height)
{
	gdouble unrounded_dpi = 0.0;
	gint rounded_dpi = 0;
	gint result = 0;
	unrounded_dpi = sqrt (pow ((gdouble) width, (gdouble) 2) + pow ((gdouble) height, (gdouble) 2)) / inches;
	rounded_dpi = (gint) unrounded_dpi;
	result = rounded_dpi;
	return result;
}

gint
dippi_utils_greatest_common_divisor (gint a,
                                     gint b)
{
	gint result = 0;
	if (a == 0) {
		result = b;
		return result;
	}
	if (b == 0) {
		result = a;
		return result;
	}
	if (a > b) {
		result = dippi_utils_greatest_common_divisor (a % b, b);
		return result;
	} else {
		result = dippi_utils_greatest_common_divisor (a, b % a);
		return result;
	}
}

